#include "tableau.hpp"



/* Exercice 2 : remplir le tableau avec des variables aleatoires */

void remplit_tableau(double *tableau, int taille)
{
  for (int i=0; i<taille; i++)
	tableau[i] = unif();
}
/*
  Le type de retour est void : la fonction remplit_tableau a un effet de
  bord (remplir le tableau), mais ne renvoie pas de valeur.
  La fonction prend en argument l'adresse du tableau *et* sa taille. En effet,
  la seule donnee de l'adresse ne permet pas de deduire la taille du tableau.
*/




/* Exercice 3 : chercher le maximum d'un tableau */

double maximum(double *tableau, int taille)
{
  double M = tableau[0];
  /* Il ne faut pas initialiser a une valeur arbitraire (par exemple 0),
	 car la fonction ne pourrait alors pas trouver le maximum d'un
	 tableau de valeurs inferieures a cette valeur arbitraire.
  */

  for (int i=1; i<taille; i++)
	if (tableau[i]>M)
	  M = tableau[i];
  
  return M;  
}

// La version suivante ne renvoie pas la *valeur* du maximum, mais sa position dans le tableau
double i_maximum_abs(double *tableau, int taille)
{
  double M = fabs(tableau[0]);
  int i_max = 0;
  
  for (int i=1; i<taille; i++)
	if (fabs(tableau[i])>M)
	  {
		M = fabs(tableau[i]);
		i_max = i;
	  }
  
  return i_max;  
}



/* Exercice 4 : trier un tableau */

/*
  Le tri par insertion : on parcourt le tableau, en inserant
  chaque nouvel element a sa place parmi les elements deja vus
  (penser a la maniere dont on trie un jeu de cartes).
*/
void tri_insertion(double *tableau, int taille)
{
  double tampon;
  for (int i=1 ; i<taille ; i++)
	{
	  int j = i-1;
	  // A chaque passage de la boucle, les i premiers elements sont tries
	  while (tableau[j]>tableau[j+1])
		{
		  // On "fait descendre" le ieme element jusqu'a sa place
		  tampon = tableau[j];
		  tableau[j] = tableau[j+1];
		  tableau[j+1] = tampon;
		  j--;
		}
	}
  
}



/*
  Le tri rapide : on choisit un element du tableau, appele "pivot"
  (ici le premier, mais il peut etre plus efficace de le choisir au
  hasard). On place au debut du tableau tous les elements inferieurs
  au pivot et a la fin tous les elements superieurs. Le pivot est donc
  a la bonne place. On trie ensuite de maniere recursive les deux
  sous-tableaux situes de part et d'autre du pivot.
*/
void tri_rapide(double *tableau, int taille)
{
  tri_rapide_aux(tableau, 0, taille-1);
}
// La fonction auxilliaire tri_rapide_aux trie les elements du tableau entre les positions "debut" et "fin".
void tri_rapide_aux(double *tableau, int debut, int fin)
{
  if (fin <= debut)
	return; // Si le tableau ne fait que 0 ou 1 case, il est deja trie.

  
  int position_pivot = debut;
  double pivot = tableau[debut];
  /* On place tous les elements inferieurs a pivot a gauche, et tous les
	 elements superieurs a droite. Par consequent, pivot se trouve a la
	 bonne place.
  */
  for (int i=debut+1; i<fin; i++)
	if (tableau[i]<pivot)
	  {
		tableau[position_pivot] = tableau[i];
		tableau[i] = tableau[position_pivot+1];
		tableau[position_pivot+1] = pivot;
		position_pivot++;
	  }

  tri_rapide_aux(tableau, debut, position_pivot-1);
  tri_rapide_aux(tableau, position_pivot+1, fin);
}
