#ifndef _ENTIER_HPP_
#define _ENTIER_HPP_

#include <cmath>
#include <iostream>

class entier
{
private:
  int *decimale;
  unsigned nb_chiffres;
  
public:

  entier(unsigned n=0); // Constructeur qui cree un "entier" a partir d'un "int", et qui sert aussi de constructeur par defaut

  // La classe entier contient un pointeur, il faut donc reecrire le constructeur par copie, le destructeur et l'operateur =.
  entier(entier const &n); // Constructeur par copie

  ~entier() // Destructeur
  {	delete []decimale; }

  // Operateur =
  entier& operator=(entier const&);


  //Surcharge des operateurs + et *
  friend entier operator+(entier const&, entier const&);
  entier& operator+=(entier const &m);

  friend entier operator*(entier const&, entier const&);
  entier& operator*=(entier const &);


  // Affichage
  friend std::ostream &operator<<(std::ostream &, entier const&);
};




#endif /* _ENTIER_HPP_ */
