#include <iostream> // Pour inclure la bibliothèque pour les entrées/sorties



/*
  Les types entiers reprentent les entiers sur un certain nombre n de chiffres binaires (ou bits).
  Les calculs sont en fait fait modulo 2^n.
  Un entier signé est interprété comme un élément de [ -2^(n-1) , 2^(n-1)-1 ]
  Un entier non signé est interprété comme un élément de [ 0 , 2^n-1 ]
*/


int main(void)
{
  short m=1;
  std::cout << "En type short (16 bits sur ma machine, soit l'intervalle [-32768, 32767])\n";
  // note : '\n' représente également un saut de ligne (comme std::cout)
  for (int i=0 ; i<6 ; i++)
	{
	  std::cout << "10^" << i << " = ";
	  std::cout << m << std::endl;
	  m *= 10;
	}

  int n=1;
  std::cout << "\nEn type int (32 bits sur ma machine, soit l'intervalle [-2147483648, 2147483647])\n";
  for (int i=0 ; i<11 ; i++)
	{
	  std::cout << "10^" << i << " = ";
	  std::cout << n << std::endl;
	  n *= 10;
	}
  
  unsigned int p;
  std::cout << "\nEn type int non signé, -1 vaut "<< p-1;
  

  // Les caractères sont représentés par un type entier, correspondant à leur code ASCII
  char a = 65;
  std::cout << "\nLe caractère de numéro 65 : " << a;
  int q = 'A';
  std::cout << "\nLe numéro du caractère \'A\' : " << q << std::endl;
  
  
  return 0;
}
