#include <iostream>

void plus_un_v1(int m)
// Passage par valeur.
// Cette fonction ne modifie *pas* ses arguments.
{
  m++;
}


void plus_un_v2(int *m)
// Passage par adresse (avec pointeurs)
// Cette fonction modifie la valeur situe a l'adresse qui lui est donnee en argument.
{
  (*m)++;
}


void plus_un_v3(int &m)
// Passage par adresse (avec reference)
// Meme chose qu'avec les pointeurs, mais la syntaxe est plus naturelle.
{
  m++;
}


int main(void)
{
  int n=0;

  std::cout << n << std::endl;
  plus_un_v1(n);
  std::cout << n << std::endl;
  
  plus_un_v2(&n);
  // Avec des pointeurs : on fournit a la fonction l'*adresse* de la variable n.
  std::cout << n << std::endl;
  
  plus_un_v3(n);
  // Avec des pointeurs : on ecrit simplement "n"
  std::cout << n << std::endl;
  
}
