#include <iostream>

/*
  Un exemple d'heritage. La classe A comporte une methode f1.
  La classe B comporte une methode f2 et herite de A. Par
  consequent, une variable de type B comporte la methode f2
  *et* la methode f1 (les membres de A sont aussi present dans B).
 */

class A
{
public:
  void f1(void)
  {std::cout << "f1 (qui n'est definie que dans A)\n";}
};



class B : public A
{
public: 
  void f2(void)
  {std::cout << "f2 (qui n'est definie que dans B)\n";}
};

  

int main(void)
{
  A a; // Une variable de la classe A

  a.f1();
  //a.f2(); // Ici, on aurait une erreur de compilation, car la classe A ne contient pas de fonction f2


  std::cout << std::endl;

  
  B b; // Une variable de la classe B

  b.f1();
  b.f2();

  
  std::cout << std::endl;

  
  A *b_comme_A = &b; // La variable b, qui est de type B, mais "vue comme une variable de type A"

  b_comme_A->f1();
  //b_comme_A->f2(); // Ici, on aurait une erreur de compilation, car la classe A ne contient pas de fonction f2
  
  
  return 0;
}
