#include "alea.hpp"
#include <iostream>


/*
  Une classe correspondant aux variables uniforme sur l'intervalle [a,b].
*/
class unif : public va_reelle
{
private:
  double a,b;
public:
  unif(double b_=1, double a_=0) : a(a_), b(b_) {};
  // Un constructeur. Par defaut, on a une variable uniforme sur [0,1].
  
  double operator() (void) const
  {
	return a + (b-a) * unif01();
  }

  double g(void) const 
  {return a;}
  double d(void) const 
  {return b;}
   
};
  



int main(void)
{
  unif U(2,0); // Une variable uniforme sur [0,2]

  int n = 10000;
  
  std::cout << "U suit la loi uniforme sur [ " << U.g() << " , " << U.d() << " ]\n";
  std::cout << "Par methode de Monte Carlo avec " << n << " tirages, on trouve :\n";
  std::cout << "moyenne de U  : " << U.E(n) << " (valeur theorique : " << (U.g()+U.d())/2 << " )\n";
  std::cout << "variance de U : " << U.V(n) << " (valeur theorique : " << (U.d()-U.g())*(U.d()-U.g())/12 << " )\n";

  std::cout << "Fonction de repartition de U :\n";
  std::cout << "F(0) = "<< U.fdr(0,n) << " valeur theorique : 0\n";
  std::cout << "F(0.5) = "<< U.fdr(0.5,n) << " valeur theorique : 0.25\n";
  std::cout << "F(1) = "<< U.fdr(1,n) << " valeur theorique : 0.5\n";
  std::cout << "F(1.5) = "<< U.fdr(1.5,n) << " valeur theorique : 0.75\n";
  
  
  return 0;
}
